<?php

namespace AppBundle\Repository\User;

use AppBundle\Entity\User\Subscription;
use function PHPSTORM_META\type;
use Symfony\Bundle\SecurityBundle\SecurityBundle;
use AppBundle\Object\CandidateSearch;

/**
 * SubscriptionRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class SubscriptionRepository extends \Doctrine\ORM\EntityRepository
{
    public function queryAll($user = null)
    {
        $qb = $this->createQueryBuilder('s');

        if($user) {
//            dump($user->getId());die;
            $qb->where('s.createdBy = :user')
                ->setParameter(':user', $user->getId());
        }

        $qb->orderBy('s.contactDate', 'DESC');

        return $qb;
    }

    public function findCandidates($filters = null)
    {
        $qb = $this->createQueryBuilder('s');

        if($filters and $filters->getType()){
            $qb->where('s.type = :type')
                ->setParameter('type', $filters->getType());
        } else {
            $qb->where('s.type IN( :type1, :type2, :type3)')
                ->setParameter('type1', Subscription::TYPE_CANDIDATE)
                ->setParameter('type2', Subscription::TYPE_CANDIDATE_SPONSOR)
                ->setParameter('type3', Subscription::TYPE_RANDOM);
        }

        if($filters and $filters->getLabel()){
            $qb->andWhere('s.firstName like :label or s.name like :label')
                ->setParameter('label', '%'.$filters->getLabel().'%');
        }
        if($filters and $filters->getStatus()){
            $qb->andWhere('s.status = :status')
                ->setParameter('status', $filters->getStatus());
        }

        if($filters and $filters->getSortOrder()){
            switch($filters->getSortOrder()) {
                default:
                case 'dateDesc': $qb->orderBy('s.contactDate', 'DESC'); break;
                case 'dateAsc': $qb->orderBy('s.contactDate', 'ASC'); break;
                case 'nameAsc': $qb->orderBy('s.name', 'ASC');
                $qb->addOrderBy('s.firstName', 'ASC');
                break;
            }
        } else
            $qb->orderBy('s.contactDate', 'DESC');

        return $qb;
    }
    
    protected function getCandidateType($resType)
    {
        switch($resType) {
            case Subscription::TYPE_RANDOM: return 'random';
            case Subscription::TYPE_CANDIDATE_SPONSOR: return 'sponsor';
            case Subscription::TYPE_CANDIDATE: return 'candidate';
        }
        return null;
    }
    
    protected function getCandidateStatus($resStatus)
    {
        switch($resStatus) {
            case Subscription::STATUS_CANCELLED: return 'cancelled';
            case Subscription::STATUS_WAITING: return 'waiting';
            case Subscription::STATUS_OK: return 'ok';
        }
        return null;
    }

    protected function initResults(&$results, $type)
    {
        $results[$type] = array();
        $results[$type]['waiting'] = 0;
        $results[$type]['ok'] = 0;
        $results[$type]['cancelled'] = 0;
    }

    public function resultCandidates($filters = null)
    {
        $qb = $this->findCandidates($filters);

        $qb->select('COUNT(s.id) as nb, s.type as type, s.status as status')
            ->groupBy('s.status')
        ->addGroupBy('s.type')
            ->orderBy('s.type,s.status', 'ASC')
        ;
        $res = $qb->getQuery()->getResult();
        $results = array();
        $this->initResults($results, 'candidate');
        $this->initResults($results, 'sponsor');
        $this->initResults($results, 'random');

        foreach ($res as $s) {
            $type = $this->getCandidateType($s['type']);
            $status = $this->getCandidateStatus($s['status']);
            $results[$type][$status] = $s['nb'];
        }
        return $results;
    }
}
